## nlopt 2.7.0

=== CMakeLists.txt ===
#==============================================================================
# NLOPT CMake file
#
# NLopt is a free/open-source library for nonlinear optimization, providing
# a common interface for a number of different free optimization routines
# available online as well as original implementations of various other
# algorithms
# WEBSITE: http://ab-initio.mit.edu/wiki/index.php/NLopt
# AUTHOR: Steven G. Johnson
#
# This CMakeLists.txt file was created to compile NLOPT with the CMAKE utility.
# Benoit Scherrer, 2010 CRL, Harvard Medical School
# Copyright (c) 2008-2009 Children's Hospital Boston
#==============================================================================
cmake_minimum_required (VERSION 2.8.11)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (nlopt)

#==============================================================================
# version
set (NLOPT_MAJOR_VERSION "2")
set (NLOPT_MINOR_VERSION "7")
set (NLOPT_BUGFIX_VERSION "0")
set (NLOPT_VERSION_STRING ${NLOPT_MAJOR_VERSION}.${NLOPT_MINOR_VERSION}.${NLOPT_BUGFIX_VERSION})
message (STATUS "NLopt version ${NLOPT_VERSION_STRING}")

# This is the ABI version number, which differes from the API version above
# (it indicates ABI compatibility), but they are typically incremented together.
set(SO_MAJOR 0)
set(SO_MINOR 11)
set(SO_PATCH 0)
#==============================================================================

list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

option (NLOPT_CXX "enable cxx routines" ON)
option (NLOPT_FORTRAN "enable fortran tests" OFF)
option (BUILD_SHARED_LIBS "Build NLopt as a shared library" ON)
option (NLOPT_PYTHON "build python bindings" ON)
option (NLOPT_OCTAVE "build octave bindings" ON)
option (NLOPT_MATLAB "build matlab bindings" ON)
option (NLOPT_GUILE "build guile bindings" ON)
option (NLOPT_SWIG "use SWIG to build bindings" ON)

if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option (NLOPT_TESTS "build unit tests" ON)
else ()
  option (NLOPT_TESTS "build unit tests" OFF)
endif ()

if (NLOPT_FORTRAN)
  enable_language (Fortran)
endif ()

include (GNUInstallDirs)

# Offer the user the choice of overriding the installation directories
set (INSTALL_LIB_DIR     ${CMAKE_INSTALL_LIBDIR}        CACHE PATH "Installation directory for libraries")
set (INSTALL_BIN_DIR     ${CMAKE_INSTALL_BINDIR}        CACHE PATH "Installation directory for executables")
set (INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}    CACHE PATH "Installation directory for header files")
set (INSTALL_DATA_DIR    ${CMAKE_INSTALL_DATADIR}/nlopt CACHE PATH "Installation directory for data files")
set (INSTALL_MAN_DIR     ${CMAKE_INSTALL_MANDIR}        CACHE PATH "Installation directory for man documentation")
set (INSTALL_CMAKE_DIR   ${INSTALL_LIB_DIR}/cmake/nlopt CACHE PATH "Installation directory for cmake config files")

# Make relative paths absolute (needed later on)
foreach (p LIB BIN INCLUDE DATA CMAKE)
  set (var INSTALL_${p}_DIR)
  set (RELATIVE_INSTALL_${p}_DIR ${INSTALL_${p}_DIR})
  if (NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif ()
endforeach ()


set (CMAKE_INSTALL_RPATH ${INSTALL_LIB_DIR})
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
if(POLICY CMP0042)
  # Set MACOSX_RPATH to ON
  cmake_policy(SET CMP0042 NEW)
endif()
if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif ()

include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckTypeSize)
include (CheckCCompilerFlag)
include (CheckCXXSymbolExists)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

#==============================================================================
# COMPILATION CHECKINGS and CONFIGURATION GENERATION
#==============================================================================
check_include_file (dlfcn.h HAVE_DLFCN_H)
check_include_file (getopt.h HAVE_GETOPT_H)
check_include_file (unistd.h HAVE_UNISTD_H)
check_include_file (string.h HAVE_STRING_H)
check_include_file (strings.h HAVE_STRINGS_H)
check_include_file (inttypes.h HAVE_INTTYPES_H)
check_include_file (memory.h HAVE_MEMORY_H)
check_include_file (stdlib.h HAVE_STDLIB_H)
check_include_file (stdint.h HAVE_STDINT_H)
check_include_file (time.h HAVE_TIME_H)
check_include_file (sys/types.h HAVE_SYS_TYPES_H)
check_include_file (sys/stat.h HAVE_SYS_STAT_H)
check_include_file (sys/time.h HAVE_SYS_TIME_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()
check_function_exists (getpid HAVE_GETPID)
check_function_exists (syscall HAVE_GETTID_SYSCALL)
check_function_exists (isinf HAVE_ISINF)
check_function_exists (isnan HAVE_ISNAN)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (qsort_r HAVE_QSORT_R)
check_function_exists (time HAVE_TIME)
check_function_exists (copysign HAVE_COPYSIGN)
check_function_exists (getopt HAVE_GETOPT)
check_type_size ("uint32_t" SIZEOF_UINT32_T)
set (HAVE_UINT32_T ${SIZEOF_UINT32_T})
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)

check_library_exists ("m" sqrt "" HAVE_LIBM)
if (HAVE_LIBM)
  set (M_LIBRARY m)
endif()

if (NOT DEFINED HAVE_FPCLASSIFY)
  message(STATUS "Looking for fpclassify")
  file (WRITE ${PROJECT_BINARY_DIR}/fpclassify.c "#include <math.h>\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "int main(void) {\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "if (!fpclassify(3.14159)) fpclassify(2.7183);\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "  return 0; }\n")
  try_compile (HAVE_FPCLASSIFY
  ${PROJECT_BINARY_DIR}/build_fpclassify
  ${PROJECT_BINARY_DIR}/fpclassify.c
  CMAKE_FLAGS -DLINK_LIBRARIES=m)
  message(STATUS "Looking for fpclassify - ${HAVE_FPCLASSIFY}")
endif ()

option (WITH_THREADLOCAL "check thread local keyword" ON)
if (WITH_THREADLOCAL AND NOT DEFINED THREADLOCAL)
  foreach (_THREADLOCAL_KEY "__thread" "__declspec(thread)")
    unset (HAVE_THREAD_LOCAL_STORAGE CACHE)
    check_c_source_compiles("
    ${_THREADLOCAL_KEY} int tls;

    int main(void) {
        return 0;
    }" HAVE_THREAD_LOCAL_STORAGE)
    if (HAVE_THREAD_LOCAL_STORAGE)
      set (THREADLOCAL ${_THREADLOCAL_KEY} CACHE STRING "Thread local keyword")
    endif ()
  endforeach()
endif ()


if (NLOPT_CXX OR NLOPT_PYTHON OR NLOPT_GUILE OR NLOPT_OCTAVE)
  check_cxx_symbol_exists (__cplusplus ciso646 SYSTEM_HAS_CXX)
  if (SYSTEM_HAS_CXX)
    check_cxx_compiler_flag ("-std=c++11" SUPPORTS_STDCXX11)
    if (SUPPORTS_STDCXX11)
      set (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
      if (NLOPT_CXX)
        set (NLOPT_CXX11 ON)
      endif ()
    endif ()
  else()
    message (FATAL_ERROR "The compiler doesn't support CXX.")
  endif ()
endif ()

#==============================================================================
# CREATE nlopt_config.h
#==============================================================================

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt_config.h IMMEDIATE)

# pkgconfig file
if (UNIX OR MINGW)
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt.pc.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc @ONLY)
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc DESTINATION ${RELATIVE_INSTALL_LIB_DIR}/pkgconfig)
endif ()

#==============================================================================
# nlopt LIBRARY TARGET (SHARED OR STATIC)
#==============================================================================

set (NLOPT_HEADERS
  src/api/nlopt.h ${PROJECT_BINARY_DIR}/nlopt.hpp ${PROJECT_BINARY_DIR}/nlopt.f
)

add_custom_command (OUTPUT nlopt.hpp
  COMMAND ${CMAKE_COMMAND} -DAPI_SOURCE_DIR=${PROJECT_SOURCE_DIR}/src/api -P ${PROJECT_SOURCE_DIR}/cmake/generate-cpp.cmake
  MAIN_DEPENDENCY src/api/nlopt-in.hpp)
add_custom_target (generate-cpp ALL DEPENDS nlopt.hpp)

add_custom_command (OUTPUT nlopt.f
  COMMAND ${CMAKE_COMMAND} -DAPI_SOURCE_DIR=${PROJECT_SOURCE_DIR}/src/api -P ${PROJECT_SOURCE_DIR}/cmake/generate-fortran.cmake
  MAIN_DEPENDENCY src/api/nlopt.h)
add_custom_target (generate-fortran ALL DEPENDS nlopt.f)

set (NLOPT_SOURCES
  src/algs/direct/DIRect.c src/algs/direct/direct_wrap.c src/algs/direct/DIRserial.c src/algs/direct/DIRsubrout.c src/algs/direct/direct-internal.h src/algs/direct/direct.h
  src/algs/cdirect/cdirect.c src/algs/cdirect/hybrid.c src/algs/cdirect/cdirect.h
  src/algs/praxis/praxis.c src/algs/praxis/praxis.h
  src/algs/luksan/plis.c src/algs/luksan/plip.c src/algs/luksan/pnet.c src/algs/luksan/mssubs.c src/algs/luksan/pssubs.c src/algs/luksan/luksan.h
  src/algs/crs/crs.c src/algs/crs/crs.h
  src/algs/mlsl/mlsl.c src/algs/mlsl/mlsl.h
  src/algs/mma/mma.c src/algs/mma/mma.h src/algs/mma/ccsa_quadratic.c
  src/algs/cobyla/cobyla.c src/algs/cobyla/cobyla.h
  src/algs/newuoa/newuoa.c src/algs/newuoa/newuoa.h
  src/algs/neldermead/nldrmd.c src/algs/neldermead/neldermead.h src/algs/neldermead/sbplx.c
  src/algs/auglag/auglag.c src/algs/auglag/auglag.h
  src/algs/bobyqa/bobyqa.c src/algs/bobyqa/bobyqa.h
  src/algs/isres/isres.c src/algs/isres/isres.h
  src/algs/slsqp/slsqp.c src/algs/slsqp/slsqp.h
  src/algs/esch/esch.c src/algs/esch/esch.h
  src/api/general.c src/api/options.c src/api/optimize.c src/api/deprecated.c src/api/nlopt-internal.h src/api/nlopt.h src/api/f77api.c src/api/f77funcs.h src/api/f77funcs_.h ${PROJECT_BINARY_DIR}/nlopt.hpp
  src/util/mt19937ar.c src/util/sobolseq.c src/util/soboldata.h src/util/timer.c src/util/stop.c src/util/nlopt-util.h src/util/redblack.c src/util/redblack.h src/util/qsort_r.c src/util/rescale.c
)

if (NLOPT_CXX)
  list (APPEND NLOPT_SOURCES src/algs/stogo/global.cc src/algs/stogo/linalg.cc src/algs/stogo/local.cc src/algs/stogo/stogo.cc src/algs/stogo/tools.cc
        src/algs/stogo/global.h src/algs/stogo/linalg.h src/algs/stogo/local.h src/algs/stogo/stogo_config.h src/algs/stogo/stogo.h src/algs/stogo/tools.h)
endif ()
if (NLOPT_CXX11)
  list (APPEND NLOPT_SOURCES src/algs/ags/data_types.hpp src/algs/ags/evolvent.hpp src/algs/ags/evolvent.cc src/algs/ags/solver.hpp src/algs/ags/solver.cc
  src/algs/ags/local_optimizer.hpp src/algs/ags/local_optimizer.cc src/algs/ags/ags.h src/algs/ags/ags.cc)
endif ()

install (FILES ${NLOPT_HEADERS} DESTINATION ${RELATIVE_INSTALL_INCLUDE_DIR})

set (nlopt_lib nlopt)
add_library (${nlopt_lib} ${NLOPT_SOURCES})
add_dependencies(${nlopt_lib} generate-cpp)
target_link_libraries (${nlopt_lib} ${M_LIBRARY})

set_target_properties (${nlopt_lib} PROPERTIES SOVERSION ${SO_MAJOR})
set_target_properties (${nlopt_lib} PROPERTIES VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}")

#==============================================================================
# INCLUDE DIRECTORIES
#==============================================================================
target_include_directories (${nlopt_lib} PRIVATE
  ${PROJECT_BINARY_DIR}/src/api
  ${PROJECT_BINARY_DIR}
  src/algs/stogo
  src/algs/ags
  src/util
  src/algs/direct
  src/algs/cdirect
  src/algs/praxis
  src/algs/luksan
  src/algs/crs
  src/algs/mlsl
  src/algs/mma
  src/algs/cobyla
  src/algs/newuoa
  src/algs/neldermead
  src/algs/auglag
  src/algs/bobyqa
  src/algs/isres
  src/algs/slsqp
  src/algs/esch
  src/api)

get_target_property (NLOPT_PRIVATE_INCLUDE_DIRS ${nlopt_lib} INCLUDE_DIRECTORIES)
target_include_directories (${nlopt_lib} INTERFACE "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/api;${PROJECT_BINARY_DIR}>" "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")

if (BUILD_SHARED_LIBS)
  target_compile_definitions (${nlopt_lib} PUBLIC NLOPT_DLL)
  target_compile_definitions (${nlopt_lib} PRIVATE NLOPT_DLL_EXPORT)
endif ()

# pass -fPIC in case swig module is built with static library
if (NOT BUILD_SHARED_LIBS)
  check_c_compiler_flag (-fPIC HAS_FPIC)
  if (HAS_FPIC)
    set (CMAKE_C_FLAGS "-fPIC ${CMAKE_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "-fPIC ${CMAKE_CXX_FLAGS}")

=== debian/changelog ===
nlopt (2.7.0-4) unstable; urgency=medium

  * Team upload
  * d/libnlopt-cxx0.symbols: Remove file.
    The mangling of C++ symbols varies substantially from one
    architecture to the other, what makes impractical the maintenance
    of the symbols file.
  * d/p/set_cxx_soname.patch: Fix line number
  * d/rules: Specify a separate arch-indep override for dh_link
  * d/libnlopt-cxx0.lintian-overrides: Override Lintian warning
    no-symbols-control-file

 -- Rafael Laboissière <rafael@debian.org>  Mon, 23 Nov 2020 11:27:29 -0300

nlopt (2.7.0-3) unstable; urgency=medium

  * Team upload
  * d/libnlopt-cxx0.symbols: Remove file.
    The mangling of C++ symbols varies substantially from one
    architecture to the other, what makes impractical the maintenance
    of the symbols file.
  * d/p/set_cxx_soname.patch: Fix line number
  * d/rules: Specify a separate arch-indep override for dh_link

 -- Rafael Laboissière <rafael@debian.org>  Mon, 23 Nov 2020 08:51:07 -0300

nlopt (2.7.0-2) unstable; urgency=medium

  * Team upload
  * d/libnlopt-cxx0.symbols: New file

 -- Rafael Laboissière <rafael@debian.org>  Fri, 20 Nov 2020 15:13:52 -0300

nlopt (2.7.0-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.7.0
  * d/p/set_cxx_soname.patch: Refresh for new upstream version
  * d/copyright:
    + Update upstream copyright year
    + Add myself as copyright holder of debian/* files
    + Use secure URL in Format field
  * Use Github URL for upstream Homepage and Source
  * d/copyright:
    + Simplify stanzas and general cleanup
    + Add full GPL-3+ License terms
  * d/control:
     + Bump debhelper compatibility level to 13
     + Bump Standards-Version to 4.5.1 (no changes needed)
     + Add Rules-Requires-Root: no
  * d/libnlopt0.lintian-overrides:
    + Use correct Litian tag exit-in-shared-library
    + Drop override for hardening-no-stackprotector
  * d/libnlopt-guile0.lintian-overrides: Drop overrides
  * Migrate to guile-3.0 (Closes: 969695)
    + d/control: Set build-dependency and dependency on guile-3.0(-dev)
    + d/p/detect-guile-3.0.patch: New patch
  * Use system (Sphinx) fonts instead of shipping them
    + d/control: nlopt-doc depends on sphinx-rtd-theme-common
    + d/rules: Remove site/fonts/ directory before invoking dh_links
    + d/nlopt-doc.links: New file
  * d/rules: Use execute_(before|after)_ instead of override_
    debhelper commands
  * d/u/metadata: New file
  * d/clean: New file
  * d/nlopt-doc.lintian-overrides: Add override for compressed-duplicate
  * d/u/metadata: New file
  * Add DEP-3 headers to the Debian patches
  * d/libnlopt0.symbols: Update list of symbols for new upstream version

 -- Rafael Laboissière <rafael@debian.org>  Thu, 19 Nov 2020 05:05:39 -0300

=== debian/control ===
Source: nlopt
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               chrpath,
               cmake,
               dh-octave (>= 0.7.1),
               dh-python,
               python3-all-dev,
               python3-numpy,
               guile-3.0-dev,
               swig
Build-Depends-Indep: mkdocs,
                     libjs-highlight.js,
                     libjs-jquery,
                     libjs-mathjax
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/nlopt
Vcs-Git: https://salsa.debian.org/science-team/nlopt.git
Homepage: https://github.com/stevengj/nlopt
Rules-Requires-Root: no

Package: libnlopt0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the shared libraries required to run programs
 compiled with NLopt. To compile your own programs you also need to
 install libnlopt-dev.

Package: libnlopt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnlopt0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: nonlinear optimization library -- development package
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the header files, static libraries and symbolic
 links that developers using NLopt library will need.

Package: libnlopt-cxx0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library (C++ interface)
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the shared libraries required to run programs
 compiled with NLopt in C++. To compile your own programs you also need to
 install libnlopt-cxx-dev.

Package: libnlopt-cxx-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnlopt-dev (= ${binary:Version}),
         libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: nonlinear optimization library -- development package for C++
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the header files, static libraries and symbolic
 links that developers using NLopt library with C++ will need.

Package: python3-nlopt
Architecture: any
Section: python
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Provides: ${python3:Provides}
Description: nonlinear optimization library -- Python 3 bindings
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the Python 3 bindings.

Package: octave-nlopt
Architecture: any
Multi-Arch: same
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${octave:Depends}
Description: nonlinear optimization library -- GNU Octave package
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the module for the GNU Octave.

Package: libnlopt-guile0
Architecture: any
Multi-Arch: same
Section: libs
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         guile-3.0
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library -- Guile bindings
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the bindings for GNU Guile.

Package: nlopt-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-highlight.js,
         libjs-jquery,
         libjs-mathjax,
         sphinx-rtd-theme-common
Description: nonlinear optimization library (documentation)
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the HTML documentation for nlopt.

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = obj-$(shell dpkg-architecture  -q DEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DH_ALWAYS_EXCLUDE=__pycache__

PY3_DEFAULT = $(shell py3versions  -dv)
PY3_ALT = $(shell py3versions  -rv | sed "s/$(PY3_DEFAULT)//")

%:
	dh $@  --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -a -- -DNLOPT_FORTRAN=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$(PY3_DEFAULT) -DCMAKE_SKIP_INSTALL_RPATH=TRUE
	for py3alt in $(PY3_ALT); do dh_auto_configure -a --builddirectory=$(BUILDDIR)-python$${py3alt} -- -DNLOPT_FORTRAN=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$${py3alt} -DCMAKE_SKIP_INSTALL_RPATH=TRUE; done
	dh_auto_configure -a --builddirectory=$(BUILDDIR)-c-only -- -DNLOPT_CXX=OFF -DNLOPT_PYTHON=OFF -DNLOPT_OCTAVE=OFF -DNLOPT_GUILE=OFF -DNLOPT_SWIG=OFF -DCMAKE_SKIP_INSTALL_RPATH=TRUE

execute_after_dh_auto_build-arch:
	for py3alt in $(PY3_ALT); do dh_auto_build --builddirectory=$(BUILDDIR)-python$${py3alt}; done
	dh_auto_build --builddirectory=$(BUILDDIR)-c-only

override_dh_auto_build-indep:
	mkdocs build

override_dh_auto_install-arch:
	dh_auto_install -a
	dh_auto_install -a --builddirectory=$(BUILDDIR)-c-only --destdir=debian/tmp-c-only
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc
	sed "s/-lnlopt/-lnlopt_cxx/" -i debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc

override_dh_auto_install-indep:

override_dh_python3-arch:
	for py3alt in $(PY3_ALT); do \
		py3short=`echo $${py3alt} | sed "s/\.//g"`; \
		cp $(BUILDDIR)-python$${py3alt}/src/swig/_nlopt.so debian/python3-nlopt/usr/lib/python3/dist-packages/_nlopt.cpython-$${py3short}.so; \
		chrpath -d debian/python3-nlopt/usr/lib/python3/dist-packages/_nlopt.cpython-$${py3short}.so; \
	done
	dh_python3 -a

override_dh_auto_test-indep:
	echo No tests to run in arch-indep build.

execute_after_dh_strip:
	find debian/octave-nlopt/usr/lib -name *.oct | \
		xargs strip --strip-unneeded --remove-section=.comment

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/python3/dist-packages

execute_after_dh_shlibdeps:
	dh_octave_substvar

execute_after_dh_install-arch:
	# Remove C++ header from C interface
	find debian/libnlopt-dev -name nlopt.hpp -delete

override_dh_installdocs-indep:
	dh_installdocs -X js/jquery
	grep highlight.min.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*highlight.min.js\"|src=\"/usr/share/javascript/highlight.js/highlight.min.js\"|" -i
	grep js/jquery debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*js/jquery*.min.js|src=\"/usr/share/javascript/jquery/jquery.min.js|" -i
	grep -i mathjax.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\"https://cdn.mathjax.org/mathjax/latest/MathJax.js|src=\"/usr/share/javascript/mathjax/MathJax.js|" -i
	grep github.min.css debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|href=\".*github.min.css\"|src=\"/usr/share/javascript/highlight.js/styles/github.css\"|" -i

execute_before_dh_link-arch:
	for package in libnlopt-dev libnlopt-guile0 octave-nlopt python3-nlopt; do \
		rm -rf debian/$$package/usr/share/doc/$$package; \
	done

execute_before_dh_link-indep:
	rm -rf debian/nlopt-doc/usr/share/doc/nlopt-doc/site/fonts

## nlopt 2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # Benoit Scherrer, 2010 CRL, Harvard Medical School
 # Copyright (c) 2008-2009 Children's Hospital Boston
 #==============================================================================
-cmake_minimum_required (VERSION 2.8.11)
+cmake_minimum_required (VERSION 3.2)
 
 if (NOT DEFINED CMAKE_BUILD_TYPE)
   set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
@@ -24,7 +24,7 @@
 # version
 set (NLOPT_MAJOR_VERSION "2")
 set (NLOPT_MINOR_VERSION "7")
-set (NLOPT_BUGFIX_VERSION "0")
+set (NLOPT_BUGFIX_VERSION "1")
 set (NLOPT_VERSION_STRING ${NLOPT_MAJOR_VERSION}.${NLOPT_MINOR_VERSION}.${NLOPT_BUGFIX_VERSION})
 message (STATUS "NLopt version ${NLOPT_VERSION_STRING}")
 
@@ -32,7 +32,7 @@
 # (it indicates ABI compatibility), but they are typically incremented together.
 set(SO_MAJOR 0)
 set(SO_MINOR 11)
-set(SO_PATCH 0)
+set(SO_PATCH 1)
 #==============================================================================
 
 list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
@@ -98,18 +98,10 @@
 #==============================================================================
 # COMPILATION CHECKINGS and CONFIGURATION GENERATION
 #==============================================================================
-check_include_file (dlfcn.h HAVE_DLFCN_H)
 check_include_file (getopt.h HAVE_GETOPT_H)
 check_include_file (unistd.h HAVE_UNISTD_H)
-check_include_file (string.h HAVE_STRING_H)
-check_include_file (strings.h HAVE_STRINGS_H)
-check_include_file (inttypes.h HAVE_INTTYPES_H)
-check_include_file (memory.h HAVE_MEMORY_H)
-check_include_file (stdlib.h HAVE_STDLIB_H)
 check_include_file (stdint.h HAVE_STDINT_H)
 check_include_file (time.h HAVE_TIME_H)
-check_include_file (sys/types.h HAVE_SYS_TYPES_H)
-check_include_file (sys/stat.h HAVE_SYS_STAT_H)
 check_include_file (sys/time.h HAVE_SYS_TIME_H)
 if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
   set (TIME_WITH_SYS_TIME TRUE)
@@ -287,3 +279,14 @@
   if (HAS_FPIC)
     set (CMAKE_C_FLAGS "-fPIC ${CMAKE_C_FLAGS}")
     set (CMAKE_CXX_FLAGS "-fPIC ${CMAKE_CXX_FLAGS}")
+  endif ()
+endif ()
+
+install ( TARGETS ${nlopt_lib}
+          EXPORT  NLoptLibraryDepends
+          RUNTIME DESTINATION ${RELATIVE_INSTALL_BIN_DIR}
+          LIBRARY DESTINATION ${RELATIVE_INSTALL_LIB_DIR}
+          ARCHIVE DESTINATION ${RELATIVE_INSTALL_LIB_DIR}
+        )
+
+if (MSVC AND BUILD_SHARED_LIBS)

=== test/CMakeLists.txt ===
add_custom_target (tests)

add_executable (t_tutorial t_tutorial.cxx)
target_link_libraries (t_tutorial ${nlopt_lib})
add_dependencies (tests t_tutorial)
target_include_directories (t_tutorial PRIVATE ${NLOPT_PRIVATE_INCLUDE_DIRS})
add_test (NAME check_tutorial COMMAND t_tutorial)
if (CMAKE_HOST_SYSTEM_NAME MATCHES Windows)
  set_tests_properties (check_tutorial PROPERTIES ENVIRONMENT "PATH=${PROJECT_BINARY_DIR}\\${CMAKE_BUILD_TYPE};$ENV{PATH}")  # to load dll
endif ()

# have to add timer.c and mt19937ar.c as symbols are declared extern
set (testopt_sources testfuncs.c testfuncs.h testopt.c ${PROJECT_SOURCE_DIR}/src/util/timer.c ${PROJECT_SOURCE_DIR}/src/util/mt19937ar.c)
if (NOT HAVE_GETOPT OR NOT HAVE_GETOPT_H)
  list (APPEND testopt_sources ${PROJECT_SOURCE_DIR}/src/util/nlopt-getopt.c)
endif ()
add_executable (testopt ${testopt_sources})
target_link_libraries (testopt ${nlopt_lib})
target_include_directories (testopt PRIVATE ${NLOPT_PRIVATE_INCLUDE_DIRS})
add_dependencies (tests testopt)

if (NLOPT_CXX)
  set_target_properties(testopt PROPERTIES LINKER_LANGUAGE CXX)
endif ()

foreach (algo_index RANGE 29)# 43
  foreach (obj_index RANGE 1)# 21
    set (enable_ TRUE)
    # cxx stogo
    if (NOT NLOPT_CXX)
      if (algo_index STREQUAL 8 OR algo_index STREQUAL 9)
        set (enable_ FALSE)
      endif ()
    endif ()
    # cxx11 ags
    if (NOT NLOPT_CXX11 AND algo_index STREQUAL 43)
      set (enable_ FALSE)
    endif ()
    # L-BFGS
    if (algo_index STREQUAL 10)
      set (enable_ FALSE)
    endif ()
    # LN_NEWUOA_BOUND timeouts on msvc
    if (algo_index STREQUAL 27)
      set (enable_ FALSE)
    endif ()
    if (enable_)
      add_test (NAME testopt_algo${algo_index}_obj${obj_index} COMMAND testopt -r 0 -a ${algo_index} -o ${obj_index})
      if (CMAKE_HOST_SYSTEM_NAME MATCHES Windows)
        set_tests_properties (testopt_algo${algo_index}_obj${obj_index} PROPERTIES ENVIRONMENT "PATH=${PROJECT_BINARY_DIR}\\${CMAKE_BUILD_TYPE};$ENV{PATH}")  # to load dll
      endif ()
    endif ()
  endforeach ()
endforeach ()

if (NUMPY_FOUND AND PYTHONLIBS_FOUND AND (SWIG_FOUND OR (EXISTS ${PROJECT_SOURCE_DIR}/src/swig/nlopt-python.cpp)))
  set (PYINSTALLCHECK_ENVIRONMENT "LD_LIBRARY_PATH=${PROJECT_BINARY_DIR}/src/swig"
                                  "PYTHONPATH=${PROJECT_BINARY_DIR}/src/swig"
    )
  add_test (NAME test_python COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_python.py)
  set_tests_properties (test_python PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
endif ()

if (OCTAVE_FOUND)
  add_test (NAME test_octave COMMAND ${OCTAVE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_octave.m ${PROJECT_SOURCE_DIR}/src/octave ${PROJECT_BINARY_DIR}/src/octave)
endif ()

if (MATLAB_FOUND)
  add_test (NAME test_matlab COMMAND ${Matlab_MAIN_PROGRAM} -nodesktop -nosplash  -r "addpath('${PROJECT_SOURCE_DIR}/src/octave'); addpath('${PROJECT_BINARY_DIR}/src/octave'); try; run('${CMAKE_CURRENT_SOURCE_DIR}/t_matlab.m'); catch; exit(1); end; quit")
endif ()

if (GUILE_FOUND AND ((SWIG_FOUND AND SWIG_VERSION VERSION_GREATER 2.0.9) OR (EXISTS ${PROJECT_SOURCE_DIR}/src/swig/nlopt-guile.cpp)))
  set (GUILECHECK_ENVIRONMENT "LD_LIBRARY_PATH=${PROJECT_BINARY_DIR}/src/swig"
                              "GUILE_LOAD_PATH=${PROJECT_BINARY_DIR}/src/swig"
    )
  add_test (NAME test_guile COMMAND ${GUILE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_guile.scm)
  set_tests_properties (test_guile PROPERTIES ENVIRONMENT "${GUILECHECK_ENVIRONMENT}")
endif ()

if (NLOPT_FORTRAN)
  add_executable (t_fortran t_fortran.f90)
  target_link_libraries (t_fortran ${nlopt_lib})
  target_include_directories (t_fortran PRIVATE ${NLOPT_PRIVATE_INCLUDE_DIRS})
  add_test (NAME test_fortran COMMAND t_fortran)
endif ()

=== debian/changelog ===
nlopt (2.7.1-7ubuntu1) resolute; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - Avoid autopkgtest failure with -D_FORTIFY_SOURCE=3

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 31 Oct 2025 20:18:16 +0000

nlopt (2.7.1-7) unstable; urgency=medium

  * Team upload

  [ Sébastien Villemot ]
  * octave-10.patch: new patch, fixes FTBFS against Octave 10 (Closes: #1114587)

  [ Rafael Laboissière ]
  * Drop versioned dependency on dh-octave (>= 0.7.1 is satisfiable in
    oldoldstable)
  * d/control: Drop “Rules-Requires-Root: no”, which is now the default

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 25 Sep 2025 12:05:34 +0200

nlopt (2.7.1-6ubuntu4) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:16:31 +0000

nlopt (2.7.1-6ubuntu3) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:41:06 +0000

nlopt (2.7.1-6ubuntu2) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 28 Jan 2025 11:30:35 +0000

nlopt (2.7.1-6ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Avoid autopkgtest failure with -D_FORTIFY_SOURCE=3

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Nov 2024 18:22:19 +0100

nlopt (2.7.1-6) unstable; urgency=medium

  * Team upload
  * Patch: Python 3.13 support. (Closes: #1081637)

 -- Stefano Rivera <stefanor@debian.org>  Sat, 09 Nov 2024 10:23:02 -0800

nlopt (2.7.1-5ubuntu1) oracular; urgency=medium

  * Avoid autopkgtest failure with -D_FORTIFY_SOURCE=3

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 27 May 2024 14:53:27 +0000

nlopt (2.7.1-5build4) oracular; urgency=medium

  * No-change rebuild against octave-abi-59

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 14 May 2024 09:40:11 +0000

nlopt (2.7.1-5build3) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 18:42:07 +0000

nlopt (2.7.1-5build2) noble; urgency=medium

  * No-change rebuild to build with python3.12 as supported.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Nov 2023 09:23:09 +0100

nlopt (2.7.1-5build1) mantic; urgency=medium

  * No-change rebuild against octave-abi-58

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 14 Aug 2023 17:26:57 +0000

nlopt (2.7.1-5) unstable; urgency=medium

  * Team Upload.
  * Add maintscript to convert libnlopt-dev doc
    symlink to directory (Closes: #1035629)
  * Add a preinst to remove examples directory in libnlopt0
    which should be present in -dev only

 -- Nilesh Patra <nilesh@debian.org>  Sun, 14 May 2023 09:35:20 +0000

nlopt (2.7.1-4) unstable; urgency=medium

  * Team upload
  * mkdocs-1.3.patch: new patch, fixes FTBFS against mkdocs 1.3.0
    (Closes: #1009183)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 14 Apr 2022 17:10:53 +0200

nlopt (2.7.1-3) unstable; urgency=medium

  * Team upload

  [ Rafael Laboissière ]
  * Install examples (unit tests)
    + d/libnlopt-dev.examples: New file
    + d/libnlopt-dev.links: Drop file
    + d/rules: Keep the /usr/share/doc/libnlopt-dev/ directory

  [ Sébastien Villemot ]
  * octave-private-libraries.patch: new patch, fixes FTBFS against octave
    6.4.0-2

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 17 Jan 2022 11:31:45 +0100

nlopt (2.7.1-2) unstable; urgency=medium

  * Team upload
  * d/rules: Install the python3.* extension to the correct path.
    Thanks to Steve Langasek for the patch (Closes: #1001363)

 -- Rafael Laboissière <rafael@debian.org>  Sun, 12 Dec 2021 18:02:48 -0300

nlopt (2.7.1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.7.1
  * d/p/detect-guile-3.0.patch: Drop patch (applied upstream)
  * d/p/set_cxx_soname.patch: Reflect upstream changes
  * d/copyright: Reflect upstream changes
  * d/watch:
    + Drop option filenamemangle
    + Drop "version" and "script" parts of the selection rule
  * d/libnlopt-cxx0.lintian-overrides: Add override for exit-in-shared-library
  * Cope with new multiarch installation path for Python files

 -- Rafael Laboissière <rafael@debian.org>  Wed, 08 Dec 2021 08:23:51 -0300

nlopt (2.7.0-5) unstable; urgency=medium

  * Team upload
  * d/rules: Call dh_numpy3 in the override for the dh_auto_install-arch rule.
    This generates the mandatory dependency on python3-numpy-abiN for the
    python3-nlopt package.
  * d/control: Bump Standards-Version to 4.6.0 (no changes needed)
  * d/copyright: Update copyright year for the debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Fri, 12 Nov 2021 04:46:54 -0300

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: nlopt
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
 Section: math
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                chrpath,
                cmake,
-               dh-octave (>= 0.7.1),
+               dh-octave,
                dh-python,
                python3-all-dev,
                python3-numpy,
@@ -16,11 +17,10 @@
                      libjs-highlight.js,
                      libjs-jquery,
                      libjs-mathjax
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/nlopt
 Vcs-Git: https://salsa.debian.org/science-team/nlopt.git
 Homepage: https://github.com/stevengj/nlopt
-Rules-Requires-Root: no
 
 Package: libnlopt0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DH_ALWAYS_EXCLUDE=__pycache__
+
+# The lorentzfit autopkgtest fails when nlopt is built with -D_FORTIFY_SOURCE=3
+# See: https://github.com/stevengj/nlopt/issues/511
+export DEB_CPPFLAGS_MAINT_APPEND=-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
 
 PY3_DEFAULT = $(shell py3versions  -dv)
 PY3_ALT = $(shell py3versions  -rv | sed "s/$(PY3_DEFAULT)//")
@@ -28,14 +32,17 @@
 	dh_auto_install -a --builddirectory=$(BUILDDIR)-c-only --destdir=debian/tmp-c-only
 	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc
 	sed "s/-lnlopt/-lnlopt_cxx/" -i debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc
+	dh_numpy3
 
 override_dh_auto_install-indep:
 
 override_dh_python3-arch:
+	distdir=debian/python3-nlopt/usr/lib/python3/dist-packages; \
+	mkdir -p $$distdir; \
 	for py3alt in $(PY3_ALT); do \
-		py3short=`echo $${py3alt} | sed "s/\.//g"`; \
-		cp $(BUILDDIR)-python$${py3alt}/src/swig/_nlopt.so debian/python3-nlopt/usr/lib/python3/dist-packages/_nlopt.cpython-$${py3short}.so; \
-		chrpath -d debian/python3-nlopt/usr/lib/python3/dist-packages/_nlopt.cpython-$${py3short}.so; \
+	py3short=`echo $${py3alt} | sed "s/\.//g"`-`dpkg-architecture -qDEB_HOST_MULTIARCH`; \
+		cp $(BUILDDIR)-python$${py3alt}/src/swig/_nlopt.so $$distdir/_nlopt.cpython-$${py3short}.so; \
+		chrpath -d $$distdir/_nlopt.cpython-$${py3short}.so; \
 	done
 	dh_python3 -a
 
@@ -57,14 +64,14 @@
 	find debian/libnlopt-dev -name nlopt.hpp -delete
 
 override_dh_installdocs-indep:
-	dh_installdocs -X js/jquery
+	dh_installdocs --indep -X js/jquery
 	grep highlight.min.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*highlight.min.js\"|src=\"/usr/share/javascript/highlight.js/highlight.min.js\"|" -i
 	grep js/jquery debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*js/jquery*.min.js|src=\"/usr/share/javascript/jquery/jquery.min.js|" -i
 	grep -i mathjax.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\"https://cdn.mathjax.org/mathjax/latest/MathJax.js|src=\"/usr/share/javascript/mathjax/MathJax.js|" -i
 	grep github.min.css debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|href=\".*github.min.css\"|src=\"/usr/share/javascript/highlight.js/styles/github.css\"|" -i
 
 execute_before_dh_link-arch:
-	for package in libnlopt-dev libnlopt-guile0 octave-nlopt python3-nlopt; do \
+	for package in libnlopt-guile0 octave-nlopt python3-nlopt; do \
 		rm -rf debian/$$package/usr/share/doc/$$package; \
 	done

=== debian/tests/control ===
Tests: test-nlopt
Depends: @,
  gcc,
  gfortran,
  guile-2.2,
  octave,
  pkg-config,
  python3-all,
  python3-numpy
Restrictions: allow-stderr
